function [Gain_select1 Gain_select2 Gain_selectc1 Gain_selectc2]= Gain_selection(ang_lim)

[R ang]= grid_angles;

cd 'D:\Research and Development\Reflector_journal\Dominant ray model'               % Change to the desired directory
load Sageantenna                                                                    % Load the antenna pattern from datasheet

% Angles and gains from the datasheet
Angle_El = Sageantenna(:,1);
Gain_El = Sageantenna(:,2);

Angle_Az = Sageantenna(:,3);
Gain_Az = Sageantenna(:,4);

Intrp_len_Az = 0; Angle_Intrp_Az = 0; Gain_Intrp_Az = 0; Intrp_len_El = 0; Angle_Intrp_El = 0; Gain_Intrp_El = 0;

Intrp_len_Az   = [1: (length(Angle_Az)-1)/10000: length(Angle_Az)];         % Interpolated step for the azimuth angles
Angle_Intrp_Az = interp1(Angle_Az,Intrp_len_Az);                            % Interpolated azimuth angle from antenna pattern plot
Gain_Intrp_Az  = interp1(Gain_Az,Intrp_len_Az);                             % Interpolate gain in the azimuth plane from antenna pattern plot

% Elevation interpolated angles
Intrp_len_El   = [1: (length(Angle_El)-1)/10000: length(Angle_El)];         % Interpolated step for the azimuth angles
Angle_Intrp_El = interp1(Angle_El,Intrp_len_El);                            % Interpolated azimuth angle from antenna pattern plot
Gain_Intrp_El  = interp1(Gain_El,Intrp_len_El);


Angle_Intrp_Az_360 = mod((360 - Angle_Intrp_Az),360);
Angle_Intrp_El_360 = mod((360 - Angle_Intrp_El),360);

Gain_select1 = zeros(6,51);
Gain_select2 = zeros(6,51);

% For flat reflectors (finding the antenan gain corresponding to the matched angle on the receiver grid)
for ii = 1:6
    for jj = 1:51
        for kk = 1:length(Intrp_len_Az)
            if(round(ang(ii,jj))<=ang_lim)
                if(round(ang(ii,jj)) == round(Angle_Intrp_Az(kk)))              % The angle of reflection is twice the angle of incidence
                    Gain_select1(ii,jj) = Gain_Intrp_Az(kk);
                end
            end
            if(round(ang(ii,jj))<=ang_lim)
                if(round(ang(ii,jj)/2) == round(Angle_Intrp_Az(kk)))            % The angle of reflection is twice the angle of incidence
                    Gain_select2(ii,jj) = Gain_Intrp_Az(kk);
                end
            end
        end
    end
end

%% For cylinder reflector
Gain_selectc1 = zeros(6,51); Gain_selectc2 = zeros(6,51);

for ii = 1:6
    for jj = 1:51
        for kk = 1:length(Intrp_len_Az)
            if(round(ang(ii,jj)) == round(Angle_Intrp_Az(kk)))
                Gain_selectc1(ii,jj) = Gain_Intrp_Az(kk);
            end
            
            if(round(ang(ii,jj)/2) == round(Angle_Intrp_Az(kk)))
                Gain_selectc2(ii,jj) = Gain_Intrp_Az(kk);
            end
        end
    end
end
